Index: squid/src/stat.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/stat.c,v
retrieving revision 1.1.1.3.10.4.2.2
retrieving revision 1.1.1.3.10.4.2.3
diff -u -r1.1.1.3.10.4.2.2 -r1.1.1.3.10.4.2.3
--- squid/src/stat.c	14 May 2000 23:22:19 -0000	1.1.1.3.10.4.2.2
+++ squid/src/stat.c	16 May 2000 18:53:53 -0000	1.1.1.3.10.4.2.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: stat.c,v 1.1.1.3.10.4.2.2 2000/05/14 23:22:19 hno Exp $
+ * $Id: stat.c,v 1.1.1.3.10.4.2.3 2000/05/16 18:53:53 hno Exp $
  *
  * DEBUG: section 18    Cache Manager Statistics
  * AUTHOR: Harvest Derived
@@ -1010,7 +1010,7 @@
 {
     assert(dest && orig);
     /* this should take care of all the fields, but "special" ones */
-    memcpy(dest, orig, sizeof(*dest));
+    xmemcpy(dest, orig, sizeof(*dest));
     /* prepare space where to copy special entries */
     statCountersInitSpecial(dest);
     /* now handle special cases */
Index: squid/src/store.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/store.c,v
retrieving revision 1.1.1.3.10.8.2.4
retrieving revision 1.1.1.3.10.8.2.5
diff -u -r1.1.1.3.10.8.2.4 -r1.1.1.3.10.8.2.5
--- squid/src/store.c	14 May 2000 23:22:20 -0000	1.1.1.3.10.8.2.4
+++ squid/src/store.c	16 May 2000 18:53:53 -0000	1.1.1.3.10.8.2.5
@@ -1,6 +1,6 @@
 
 /*
- * $Id: store.c,v 1.1.1.3.10.8.2.4 2000/05/14 23:22:20 hno Exp $
+ * $Id: store.c,v 1.1.1.3.10.8.2.5 2000/05/16 18:53:53 hno Exp $
  *
  * DEBUG: section 20    Storage Manager
  * AUTHOR: Harvest Derived
@@ -91,9 +91,9 @@
 /*
  * local variables
  */
-int store_pages_max = 0;
-int store_swap_high = 0;
-int store_swap_low = 0;
+static int store_pages_max = 0;
+static int store_swap_high = 0;
+static int store_swap_low = 0;
 static Stack LateReleaseStack;
 
 #if URL_CHECKSUM_DEBUG
@@ -427,7 +427,7 @@
     e->swap_dirn = -1;
     e->refcount = 0;
     e->lastref = squid_curtime;
-    e->timestamp = 0;		/* set in storeTimestampsSet() */
+    e->timestamp = -1;		/* set in storeTimestampsSet() */
     e->ping_status = PING_NONE;
     EBIT_SET(e->flags, ENTRY_VALIDATED);
     return e;
@@ -504,6 +504,7 @@
 	int wrong_content_length;
 	int negative_cached;
 	int too_big;
+	int too_small;
 	int private_key;
 	int too_many_open_files;
 	int too_many_open_fds;
@@ -523,6 +524,19 @@
     return 0;
 }
 
+static int
+storeCheckTooSmall(StoreEntry * e)
+{
+    MemObject *mem = e->mem_obj;
+    if (STORE_OK == e->store_status)
+	if (mem->object_sz < Config.Store.minObjectSize)
+	    return 1;
+    if (mem->reply->content_length > -1)
+	if (mem->reply->content_length < (int) Config.Store.minObjectSize)
+	    return 1;
+    return 0;
+}
+
 int
 storeCheckCachable(StoreEntry * e)
 {
@@ -553,6 +567,9 @@
     } else if (e->mem_obj->reply->content_length > (int) Config.Store.maxObjectSize) {
 	debug(20, 2) ("storeCheckCachable: NO: too big\n");
 	store_check_cachable_hist.no.too_big++;
+    } else if (storeCheckTooSmall(e)) {
+	debug(20, 2) ("storeCheckCachable: NO: too small\n");
+	store_check_cachable_hist.no.too_small++;
     } else if (EBIT_TEST(e->flags, KEY_PRIVATE)) {
 	debug(20, 3) ("storeCheckCachable: NO: private key\n");
 	store_check_cachable_hist.no.private_key++;
@@ -595,6 +612,8 @@
 	store_check_cachable_hist.no.negative_cached);
     storeAppendPrintf(sentry, "no.too_big\t%d\n",
 	store_check_cachable_hist.no.too_big);
+    storeAppendPrintf(sentry, "no.too_small\t%d\n",
+	store_check_cachable_hist.no.too_small);
     storeAppendPrintf(sentry, "no.private_key\t%d\n",
 	store_check_cachable_hist.no.private_key);
     storeAppendPrintf(sentry, "no.too_many_open_files\t%d\n",
@@ -630,8 +649,14 @@
     if (e->mem_obj->request)
 	e->mem_obj->request->hier.store_complete_stop = current_time;
 #endif
-    InvokeHandlers(e);
+    /*
+     * We used to call InvokeHandlers, then storeSwapOut.  However,
+     * Madhukar Reddy <myreddy@persistence.com> reported that
+     * responses without content length would sometimes get released
+     * in client_side, thinking that the response is incomplete.
+     */
     storeSwapOut(e);
+    InvokeHandlers(e);
 }
 
 /*
Index: squid/src/store_client.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/store_client.c,v
retrieving revision 1.1.1.3.10.4.2.4
retrieving revision 1.1.1.3.10.4.2.5
diff -u -r1.1.1.3.10.4.2.4 -r1.1.1.3.10.4.2.5
--- squid/src/store_client.c	16 May 2000 18:44:18 -0000	1.1.1.3.10.4.2.4
+++ squid/src/store_client.c	16 May 2000 18:53:53 -0000	1.1.1.3.10.4.2.5
@@ -1,6 +1,6 @@
 
 /*
- * $Id: store_client.c,v 1.1.1.3.10.4.2.4 2000/05/16 18:44:18 hno Exp $
+ * $Id: store_client.c,v 1.1.1.3.10.4.2.5 2000/05/16 18:53:53 hno Exp $
  *
  * DEBUG: section 20    Storage Manager Client-Side Interface
  * AUTHOR: Duane Wessels
@@ -297,8 +297,8 @@
 	    /* yuck -- this causes a TCP_SWAPFAIL_MISS on the client side */
 	    storeClientCallback(sc, -1);
 	    return;
-	}
-	if (!sc->flags.disk_io_pending) {
+	} else if (!sc->flags.disk_io_pending) {
+	    sc->flags.disk_io_pending = 1;
 	    storeSwapInStart(sc);
 	    if (NULL == sc->swapin_sio) {
 		storeClientCallback(sc, -1);
Index: squid/src/store_dir.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/store_dir.c,v
retrieving revision 1.1.1.3.10.6.2.2
retrieving revision 1.1.1.3.10.6.2.3
diff -u -r1.1.1.3.10.6.2.2 -r1.1.1.3.10.6.2.3
--- squid/src/store_dir.c	14 May 2000 23:22:20 -0000	1.1.1.3.10.6.2.2
+++ squid/src/store_dir.c	16 May 2000 18:53:53 -0000	1.1.1.3.10.6.2.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: store_dir.c,v 1.1.1.3.10.6.2.2 2000/05/14 23:22:20 hno Exp $
+ * $Id: store_dir.c,v 1.1.1.3.10.6.2.3 2000/05/16 18:53:53 hno Exp $
  *
  * DEBUG: section 47    Store Directory Routines
  * AUTHOR: Duane Wessels
@@ -311,7 +311,7 @@
     int i;
     Config.Swap.maxSize = 0;
     for (i = 0; i < Config.cacheSwap.n_configured; i++) {
-	SD = &Config.cacheSwap.swapDirs[i];;
+	SD = &Config.cacheSwap.swapDirs[i];
 	Config.Swap.maxSize += SD->max_size;
 	SD->low_size = (int) (((float) SD->max_size *
 		(float) Config.Swap.lowWaterMark) / 100.0);
Index: squid/src/structs.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/structs.h,v
retrieving revision 1.1.1.3.10.8.2.6
retrieving revision 1.1.1.3.10.8.2.7
diff -u -r1.1.1.3.10.8.2.6 -r1.1.1.3.10.8.2.7
--- squid/src/structs.h	14 May 2000 23:22:20 -0000	1.1.1.3.10.8.2.6
+++ squid/src/structs.h	16 May 2000 18:53:53 -0000	1.1.1.3.10.8.2.7
@@ -1,6 +1,6 @@
 
 /*
- * $Id: structs.h,v 1.1.1.3.10.8.2.6 2000/05/14 23:22:20 hno Exp $
+ * $Id: structs.h,v 1.1.1.3.10.8.2.7 2000/05/16 18:53:53 hno Exp $
  *
  *
  * SQUID Internet Object Cache  http://squid.nlanr.net/Squid/
@@ -285,6 +285,7 @@
 	struct in_addr router;
 	struct in_addr incoming;
 	struct in_addr outgoing;
+	int version;
     } Wccp;
 #endif
     char *as_whois_server;
@@ -371,6 +372,7 @@
 	int objectsPerBucket;
 	size_t avgObjectSize;
 	size_t maxObjectSize;
+	size_t minObjectSize;
     } Store;
     struct {
 	int high;
@@ -440,6 +442,7 @@
 	size_t list_width;
 	int list_wrap;
 	char *anon_user;
+	int passive;
     } Ftp;
     refresh_t *Refresh;
     struct _cacheSwap {
@@ -503,6 +506,8 @@
     struct {
 	int enable_purge;
     } onoff;
+    uid_t effectiveUserID;
+    gid_t effectiveGroupID;
 };
 
 struct _close_handler {
Index: squid/src/test_cache_digest.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/test_cache_digest.c,v
retrieving revision 1.1.1.1.8.1
retrieving revision 1.1.1.1.8.1.2.1
diff -u -r1.1.1.1.8.1 -r1.1.1.1.8.1.2.1
--- squid/src/test_cache_digest.c	20 Apr 2000 18:14:23 -0000	1.1.1.1.8.1
+++ squid/src/test_cache_digest.c	16 May 2000 18:53:53 -0000	1.1.1.1.8.1.2.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: test_cache_digest.c,v 1.1.1.1.8.1 2000/04/20 18:14:23 hno Exp $
+ * $Id: test_cache_digest.c,v 1.1.1.1.8.1.2.1 2000/05/16 18:53:53 hno Exp $
  *
  * AUTHOR: Alex Rousskov
  *
@@ -436,7 +436,7 @@
  * strcmp(hier, "SSL_PARENT_MISS") &&
  * strcmp(hier, "DEFAULT_PARENT");
  */
-    memcpy(entry->key, storeKeyPublic(url, method_id), sizeof(entry->key));
+    xmemcpy(entry->key, storeKeyPublic(url, method_id), sizeof(entry->key));
     /*fprintf(stdout, "%s:%d: %s %s %s %s\n",
      * fname, count, method, storeKeyText(entry->key), url, hier); */
     return frOk;
Index: squid/src/tools.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/tools.c,v
retrieving revision 1.1.1.3.6.1
retrieving revision 1.1.1.3.6.1.2.1
diff -u -r1.1.1.3.6.1 -r1.1.1.3.6.1.2.1
--- squid/src/tools.c	20 Apr 2000 18:14:23 -0000	1.1.1.3.6.1
+++ squid/src/tools.c	16 May 2000 18:53:53 -0000	1.1.1.3.6.1.2.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: tools.c,v 1.1.1.3.6.1 2000/04/20 18:14:23 hno Exp $
+ * $Id: tools.c,v 1.1.1.3.6.1.2.1 2000/05/16 18:53:53 hno Exp $
  *
  * DEBUG: section 21    Misc Functions
  * AUTHOR: Harvest Derived
@@ -416,46 +416,47 @@
     const struct hostent *h = NULL;
     if (Config.visibleHostname != NULL)
 	return Config.visibleHostname;
-    if (present) {
-	(void) 0;
-    } else if (Config.Sockaddr.http->s.sin_addr.s_addr != any_addr.s_addr) {
+    if (present)
+	return host;
+    host[0] = '\0';
+    if (Config.Sockaddr.http->s.sin_addr.s_addr != any_addr.s_addr) {
 	/*
 	 * If the first http_port address has a specific address, try a
 	 * reverse DNS lookup on it.
 	 */
-	host[0] = '\0';
 	h = gethostbyaddr((char *) &Config.Sockaddr.http->s.sin_addr,
 	    sizeof(Config.Sockaddr.http->s.sin_addr), AF_INET);
 	if (h != NULL) {
 	    /* DNS lookup successful */
 	    /* use the official name from DNS lookup */
-	    strcpy(host, h->h_name);
-	    debug(50, 4) ("getMyHostname: resolved tcp_incoming_addr to '%s'\n",
+	    xstrncpy(host, h->h_name, SQUIDHOSTNAMELEN);
+	    debug(50, 4) ("getMyHostname: resolved %s to '%s'\n",
+		inet_ntoa(Config.Sockaddr.http->s.sin_addr),
 		host);
 	    present = 1;
-	} else {
-	    debug(50, 6) ("getMyHostname: failed to resolve tcp_incoming_addr\n");
+	    return host;
 	}
+	debug(50, 1) ("WARNING: failed to resolve %s to a hostname\n",
+	    inet_ntoa(Config.Sockaddr.http->s.sin_addr));
+    }
+    /*
+     * Get the host name and store it in host to return
+     */
+    if (gethostname(host, SQUIDHOSTNAMELEN) < 0) {
+	debug(50, 1) ("WARNING: gethostname failed: %s\n", xstrerror());
+    } else if ((h = gethostbyname(host)) == NULL) {
+	debug(50, 1) ("WARNING: gethostbyname failed for %s\n", host);
     } else {
-	/*
-	 * Get the host name and store it in host to return
-	 */
-	host[0] = '\0';
-	if (gethostname(host, SQUIDHOSTNAMELEN) == -1) {
-	    debug(50, 1) ("getMyHostname: gethostname failed: %s\n",
-		xstrerror());
-	} else {
-	    if ((h = gethostbyname(host)) != NULL) {
-		debug(50, 6) ("getMyHostname: '%s' resolved into '%s'\n",
-		    host, h->h_name);
-		/* DNS lookup successful */
-		/* use the official name from DNS lookup */
-		strcpy(host, h->h_name);
-	    }
-	}
+	debug(50, 6) ("getMyHostname: '%s' resolved into '%s'\n",
+	    host, h->h_name);
+	/* DNS lookup successful */
+	/* use the official name from DNS lookup */
+	xstrncpy(host, h->h_name, SQUIDHOSTNAMELEN);
 	present = 1;
+	return host;
     }
-    return present ? host : NULL;
+    fatal("Could not determine fully qualified hostname.  Please set 'visible_hostname'\n");
+    return NULL;		/* keep compiler happy */
 }
 
 const char *
@@ -480,38 +481,28 @@
 void
 leave_suid(void)
 {
-    struct passwd *pwd = NULL;
-    struct group *grp = NULL;
-    gid_t gid;
     debug(21, 3) ("leave_suid: PID %d called\n", getpid());
     if (geteuid() != 0)
 	return;
     /* Started as a root, check suid option */
     if (Config.effectiveUser == NULL)
 	return;
-    if ((pwd = getpwnam(Config.effectiveUser)) == NULL)
-	return;
-    if (Config.effectiveGroup && (grp = getgrnam(Config.effectiveGroup))) {
-	gid = grp->gr_gid;
-    } else {
-	gid = pwd->pw_gid;
-    }
 #if HAVE_SETGROUPS
-    setgroups(1, &gid);
+    setgroups(1, &Config2.effectiveGroupID);
 #endif
-    if (setgid(gid) < 0)
-	debug(50, 1) ("leave_suid: setgid: %s\n", xstrerror());
+    if (setgid(Config2.effectiveGroupID) < 0)
+	debug(50, 0) ("ALERT: setgid: %s\n", xstrerror());
     debug(21, 3) ("leave_suid: PID %d giving up root, becoming '%s'\n",
-	getpid(), pwd->pw_name);
+	getpid(), Config.effectiveUser);
 #if HAVE_SETRESUID
-    if (setresuid(pwd->pw_uid, pwd->pw_uid, 0) < 0)
-	debug(50, 1) ("leave_suid: setresuid: %s\n", xstrerror());
+    if (setresuid(Config2.effectiveUserID, Config2.effectiveUserID, 0) < 0)
+	debug(50, 0) ("ALERT: setresuid: %s\n", xstrerror());
 #elif HAVE_SETEUID
-    if (seteuid(pwd->pw_uid) < 0)
-	debug(50, 1) ("leave_suid: seteuid: %s\n", xstrerror());
+    if (seteuid(Config2.effectiveUserID) < 0)
+	debug(50, 0) ("ALERT: seteuid: %s\n", xstrerror());
 #else
-    if (setuid(pwd->pw_uid) < 0)
-	debug(50, 1) ("leave_suid: setuid: %s\n", xstrerror());
+    if (setuid(Config2.effectiveUserID) < 0)
+	debug(50, 0) ("ALERT: setuid: %s\n", xstrerror());
 #endif
 }
 
Index: squid/src/unlinkd.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/unlinkd.c,v
retrieving revision 1.1.1.3.10.3.2.2
retrieving revision 1.1.1.3.10.3.2.3
diff -u -r1.1.1.3.10.3.2.2 -r1.1.1.3.10.3.2.3
--- squid/src/unlinkd.c	2 May 2000 22:50:29 -0000	1.1.1.3.10.3.2.2
+++ squid/src/unlinkd.c	16 May 2000 18:53:53 -0000	1.1.1.3.10.3.2.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: unlinkd.c,v 1.1.1.3.10.3.2.2 2000/05/02 22:50:29 hno Exp $
+ * $Id: unlinkd.c,v 1.1.1.3.10.3.2.3 2000/05/16 18:53:53 hno Exp $
  *
  * DEBUG: section 12    Unlink Daemon
  * AUTHOR: Duane Wessels
@@ -79,6 +79,7 @@
 void
 unlinkdUnlink(const char *path)
 {
+#if USE_UNLINKD
     char buf[MAXPATHLEN];
     int l;
     int x;
@@ -141,6 +142,7 @@
     }
     Counter.unlink.requests++;
     queuelen++;
+#endif
 }
 
 void
@@ -158,6 +160,7 @@
 void
 unlinkdInit(void)
 {
+#if USE_UNLINKD
     int x;
     char *args[2];
     struct timeval slp;
@@ -189,6 +192,9 @@
     if (FD_PIPE == fd_table[unlinkd_wfd].type)
 	commUnsetNonBlocking(unlinkd_wfd);
     debug(12, 1) ("Unlinkd pipe opened on FD %d\n", unlinkd_wfd);
+#else
+    debug(12, 1) ("Unlinkd is disabled\n");
+#endif
 }
 
 #endif /* ndef UNLINK_DAEMON */
Index: squid/src/url.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/url.c,v
retrieving revision 1.1.1.3.10.2.2.1
retrieving revision 1.1.1.3.10.2.2.2
diff -u -r1.1.1.3.10.2.2.1 -r1.1.1.3.10.2.2.2
--- squid/src/url.c	14 May 2000 23:22:20 -0000	1.1.1.3.10.2.2.1
+++ squid/src/url.c	16 May 2000 18:53:53 -0000	1.1.1.3.10.2.2.2
@@ -1,6 +1,6 @@
 
 /*
- * $Id: url.c,v 1.1.1.3.10.2.2.1 2000/05/14 23:22:20 hno Exp $
+ * $Id: url.c,v 1.1.1.3.10.2.2.2 2000/05/16 18:53:53 hno Exp $
  *
  * DEBUG: section 23    URL Parsing
  * AUTHOR: Duane Wessels
@@ -127,7 +127,7 @@
      * way we expect it to.
      */
     assert(0 == matchDomainName("foo.com", "foo.com"));
-    assert(0 < matchDomainName(".foo.com", "foo.com"));
+    assert(0 == matchDomainName(".foo.com", "foo.com"));
     assert(0 == matchDomainName("foo.com", ".foo.com"));
     assert(0 == matchDomainName(".foo.com", ".foo.com"));
     assert(0 == matchDomainName("x.foo.com", ".foo.com"));
@@ -142,6 +142,7 @@
     assert(0 == matchDomainName("FOO.com", "foo.COM"));
     assert(0 < matchDomainName("bfoo.com", "afoo.com"));
     assert(0 > matchDomainName("afoo.com", "bfoo.com"));
+    assert(0 < matchDomainName("x-foo.com", ".foo.com"));
     /* more cases? */
 }
 
@@ -256,6 +257,17 @@
     }
     for (t = host; *t; t++)
 	*t = xtolower(*t);
+    if (stringHasWhitespace(host)) {
+	if (URI_WHITESPACE_STRIP == Config.uri_whitespace) {
+	    t = q = host;
+	    while (*t) {
+		if (!xisspace(*t))
+		    *q++ = *t;
+		t++;
+	    }
+	    *q = '\0';
+	}
+    }
     if (strspn(host, valid_hostname_chars) != strlen(host)) {
 	debug(23, 1) ("urlParse: Illegal character in hostname '%s'\n", host);
 	return NULL;
@@ -399,12 +411,15 @@
  *    HOST          DOMAIN        MATCH?
  * ------------- -------------    ------
  *    foo.com       foo.com         YES
- *   .foo.com       foo.com          NO
+ *   .foo.com       foo.com         YES
  *  x.foo.com       foo.com          NO
  *    foo.com      .foo.com         YES
  *   .foo.com      .foo.com         YES
  *  x.foo.com      .foo.com         YES
  *
+ *  We strip leading dots on hosts (but not domains!) so that
+ *  ".foo.com" is is always the same as "foo.com".
+ *
  *  Return values:
  *     0 means the host matches the domain
  *     1 means the host is greater than the domain
@@ -416,6 +431,8 @@
 {
     int dl;
     int hl;
+    while ('.' == *h)
+	h++;
     hl = strlen(h);
     dl = strlen(d);
     /*
@@ -458,6 +475,15 @@
     /*
      * We found different characters in the same position (from the end).
      */
+    /*
+     * If one of those character is '.' then its special.  In order
+     * for splay tree sorting to work properly, "x-foo.com" must
+     * be greater than ".foo.com" even though '-' is less than '.'.
+     */
+    if ('.' == d[dl])
+	return 1;
+    if ('.' == h[hl])
+	return -1;
     return (xtolower(h[hl]) - xtolower(d[dl]));
 }
 
Index: squid/src/wccp.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/wccp.c,v
retrieving revision 1.1.1.1.6.1
retrieving revision 1.1.1.1.6.1.2.1
diff -u -r1.1.1.1.6.1 -r1.1.1.1.6.1.2.1
--- squid/src/wccp.c	20 Apr 2000 18:14:23 -0000	1.1.1.1.6.1
+++ squid/src/wccp.c	16 May 2000 18:53:53 -0000	1.1.1.1.6.1.2.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: wccp.c,v 1.1.1.1.6.1 2000/04/20 18:14:23 hno Exp $
+ * $Id: wccp.c,v 1.1.1.1.6.1.2.1 2000/05/16 18:53:53 hno Exp $
  *
  * DEBUG: section 80    WCCP Support
  * AUTHOR: Glenn Chisholm
@@ -37,7 +37,6 @@
 #if USE_WCCP
 
 #define WCCP_PORT 2048
-#define WCCP_VERSION 4
 #define WCCP_REVISION 0
 #define WCCP_RESPONSE_SIZE 12448
 #define WCCP_ACTIVE_CACHES 32
@@ -108,7 +107,7 @@
 	return;
     memset(&wccp_here_i_am, '\0', sizeof(wccp_here_i_am));
     wccp_here_i_am.type = htonl(WCCP_HERE_I_AM);
-    wccp_here_i_am.version = htonl(WCCP_VERSION);
+    wccp_here_i_am.version = htonl(Config.Wccp.version);
     wccp_here_i_am.revision = htonl(WCCP_REVISION);
     change = 0;
     if (Config.Wccp.router.s_addr != any_addr.s_addr)
@@ -232,7 +231,7 @@
 	return;
     if (Config.Wccp.router.s_addr != from.sin_addr.s_addr)
 	return;
-    if (ntohl(wccp_i_see_you.version) != WCCP_VERSION)
+    if (ntohl(wccp_i_see_you.version) != Config.Wccp.version)
 	return;
     if (ntohl(wccp_i_see_you.type) != WCCP_I_SEE_YOU)
 	return;
Index: squid/src/whois.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/whois.c,v
retrieving revision 1.1.1.2.8.1
retrieving revision 1.1.1.2.8.1.2.1
diff -u -r1.1.1.2.8.1 -r1.1.1.2.8.1.2.1
--- squid/src/whois.c	20 Apr 2000 18:14:23 -0000	1.1.1.2.8.1
+++ squid/src/whois.c	16 May 2000 18:53:53 -0000	1.1.1.2.8.1.2.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: whois.c,v 1.1.1.2.8.1 2000/04/20 18:14:23 hno Exp $
+ * $Id: whois.c,v 1.1.1.2.8.1.2.1 2000/05/16 18:53:53 hno Exp $
  *
  * DEBUG: section 75    WHOIS protocol
  * AUTHOR: Duane Wessels, Kostas Anagnostakis
@@ -86,6 +86,7 @@
     WhoisState *p = data;
     StoreEntry *entry = p->entry;
     char *buf = memAllocate(MEM_4K_BUF);
+    MemObject *mem = entry->mem_obj;
     int len;
     Counter.syscalls.sock.reads++;
     len = read(fd, buf, 4095);
@@ -93,6 +94,8 @@
     debug(75, 3) ("whoisReadReply: FD %d read %d bytes\n", fd, len);
     debug(75, 5) ("{%s}\n", buf);
     if (len > 0) {
+	if (0 == mem->inmem_hi)
+	    mem->reply->sline.status = HTTP_OK;
 	fd_bytes(fd, len, FD_READ);
 	kb_incr(&Counter.server.all.kbytes_in, len);
 	kb_incr(&Counter.server.http.kbytes_in, len);
@@ -103,7 +106,7 @@
 	    fd, xstrerror());
 	if (ignoreErrno(errno)) {
 	    commSetSelect(fd, COMM_SELECT_READ, whoisReadReply, p, Config.Timeout.read);
-	} else if (entry->mem_obj->inmem_hi == 0) {
+	} else if (mem->inmem_hi == 0) {
 	    ErrorState *err;
 	    err = errorCon(ERR_READ_ERROR, HTTP_INTERNAL_SERVER_ERROR);
 	    err->xerrno = errno;
Index: squid/src/fs/coss/store_io_coss.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/fs/coss/store_io_coss.c,v
retrieving revision 1.1.4.8.2.4
retrieving revision 1.1.4.8.2.5
diff -u -r1.1.4.8.2.4 -r1.1.4.8.2.5
--- squid/src/fs/coss/store_io_coss.c	14 May 2000 23:22:20 -0000	1.1.4.8.2.4
+++ squid/src/fs/coss/store_io_coss.c	16 May 2000 18:53:54 -0000	1.1.4.8.2.5
@@ -198,7 +198,7 @@
     /* make local copy so we don't have to lock membuf */
     if (p) {
 	cstate->readbuffer = xmalloc(sio->st_size);
-	memcpy(cstate->readbuffer, p, sio->st_size);
+	xmemcpy(cstate->readbuffer, p, sio->st_size);
     } else {
 	/* Do the allocation */
 	/* this is the first time we've been called on a new sio
@@ -303,7 +303,7 @@
     diskoffset = sio->swap_filen + sio->offset;
     dest = storeCossMemPointerFromDiskOffset(SD, diskoffset, &membuf);
     assert(dest != NULL);
-    memcpy(dest, buf, size);
+    xmemcpy(dest, buf, size);
     sio->offset += size;
     if (free_func)
 	(free_func) (buf);
@@ -333,11 +333,11 @@
 	if (cstate->readbuffer == NULL) {
 	    cstate->readbuffer = xmalloc(sio->st_size);
 	    p = storeCossMemPointerFromDiskOffset(SD, sio->swap_filen, NULL);
-	    memcpy(cstate->readbuffer, p, sio->st_size);
+	    xmemcpy(cstate->readbuffer, p, sio->st_size);
 	    storeCossMemBufUnlock(SD, sio);
 	}
 	sio->offset += len;
-	memcpy(cstate->requestbuf, &cstate->readbuffer[cstate->requestoffset],
+	xmemcpy(cstate->requestbuf, &cstate->readbuffer[cstate->requestoffset],
 	    cstate->requestlen);
 	rlen = (size_t) cstate->requestlen;
     }
